# Changelog

All notable changes to this project will be documented in this file. See [standard-version](https://github.com/conventional-changelog/standard-version) for commit guidelines.

## [1.4.0](https://github.com/ssube/textual-engine/compare/v1.3.0...v1.4.0) (2021-06-06)


### Features

* **actor:** begin emitting commands for behavior actors ([#91](https://github.com/ssube/textual-engine/issues/91)) ([12811d8](https://github.com/ssube/textual-engine/commit/12811d8a8993e6566e98a8ad541d84d9eb238412))
* **command:** add worlds list (fixes [#104](https://github.com/ssube/textual-engine/issues/104)) ([80a3ff5](https://github.com/ssube/textual-engine/commit/80a3ff55c7f69d773db73342114890c6069e1c27))
* **loader:** check path protocol before handling (fixes [#56](https://github.com/ssube/textual-engine/issues/56)) ([e116eab](https://github.com/ssube/textual-engine/commit/e116eab9033d70156f8ec10987f4b511f5dac7a6))
* **loader:** extract URL split helper ([4d4469f](https://github.com/ssube/textual-engine/commit/4d4469f9eeb8c766c833ec74c88dde475d5b8f7b))
* **model:** add default entity templates to world template, use default scripts ([6f4e42c](https://github.com/ssube/textual-engine/commit/6f4e42c4f62928492a02b46b062f2dfb50b3246c))
* **random:** rename seed generator to alea, reflecting the algorithm used ([11d7dc9](https://github.com/ssube/textual-engine/commit/11d7dc93817f844bddfe5f77913f87d93f7519ba))
* **render:** add basic shortcut menus ([#72](https://github.com/ssube/textual-engine/issues/72)) ([ef9eef3](https://github.com/ssube/textual-engine/commit/ef9eef320dde27a6fc23fbc71eeb00f359d3cd85))
* **render:** add game over screens to React DOM and Ink renders (fixes [#97](https://github.com/ssube/textual-engine/issues/97)) ([fafc7f6](https://github.com/ssube/textual-engine/commit/fafc7f6a1ef2025f55b8f4b2f6929e63f55f04ee))
* **render:** debounce room and output updates, add mock shortcut menus ([7fa2445](https://github.com/ssube/textual-engine/commit/7fa2445dbf11cc446104b9cd0927bcb198578f53))
* **render:** make shortcut menus optional (fixes [#72](https://github.com/ssube/textual-engine/issues/72)) ([92df77b](https://github.com/ssube/textual-engine/commit/92df77be590382e0c18d9753f8ed7e52e71b2dff))
* **script:** actors drop inventory upon death (fixes [#106](https://github.com/ssube/textual-engine/issues/106)) ([f7b33cb](https://github.com/ssube/textual-engine/commit/f7b33cb32ff1fd374f26c5ea691faa9a6ae56118))
* **script:** provide and use state find helper ([55cf06c](https://github.com/ssube/textual-engine/commit/55cf06c0b128c66947614e920661be60e00b953a))
* **script:** remove direct access to state, rename signal constants, begin testing local state ([418d843](https://github.com/ssube/textual-engine/commit/418d8439691221fa14e5578bc81ead6ed96428e6))
* **state:** clarify world state vs template (fixes [#93](https://github.com/ssube/textual-engine/issues/93)) ([3869e60](https://github.com/ssube/textual-engine/commit/3869e60ebf5b216dbff20b426484c888502267f7))
* **state:** merge state creation methods, remove noop save ([d8941be](https://github.com/ssube/textual-engine/commit/d8941befa9db4f53d8a565338998818fba20cf85))
* **state:** move state creation to generator ([a2143d5](https://github.com/ssube/textual-engine/commit/a2143d5d0c0723c78b933c0b7ba9e107f0d63a97))
* **state:** provide a way for scripts to end game ([#83](https://github.com/ssube/textual-engine/issues/83)) ([66b348a](https://github.com/ssube/textual-engine/commit/66b348ac490b4ff041d2c25bb97360cafb7829c6))
* **state:** queue actor commands and step once all actors have responded (fixes [#112](https://github.com/ssube/textual-engine/issues/112)) ([61276f3](https://github.com/ssube/textual-engine/commit/61276f3a9132c603f6bc9655cbcf250f61304b34))
* **state:** remove verbs by setting script name to empty (fixes [#75](https://github.com/ssube/textual-engine/issues/75)) ([7932c5c](https://github.com/ssube/textual-engine/commit/7932c5c711f9268af6770cd3e3f5a75b192892fd))
* **state:** support loading data files that do not contain state ([#105](https://github.com/ssube/textual-engine/issues/105)) ([04a60e3](https://github.com/ssube/textual-engine/commit/04a60e3246944746d61be8089e86ed698033be7c))
* **test:** switch tests to console logging when DEBUG=TRUE ([3fb7b79](https://github.com/ssube/textual-engine/commit/3fb7b79d44c4af472c085f8bdba48e584217726e))
* **util:** add collection to track queue completion ([6fa2128](https://github.com/ssube/textual-engine/commit/6fa21282c48f8be521593b89db5cd89065aa7094))
* **util:** pass config to managed services ([8c8e6c3](https://github.com/ssube/textual-engine/commit/8c8e6c33fe9d77bbe2712c34e854778567a9a448))
* **util:** use page URL for config paths ([25d57b5](https://github.com/ssube/textual-engine/commit/25d57b5899593cb6f28c0e6ca15bbe041eeee29a))
* add and use catch-and-log helper ([f5d2525](https://github.com/ssube/textual-engine/commit/f5d2525760b0cb2af5ad1e31ee3151cc695d714c))
* add argument to run commands when state starts (fixes [#79](https://github.com/ssube/textual-engine/issues/79)) ([6148dea](https://github.com/ssube/textual-engine/commit/6148dea771b820af75bf788ff6d75816690c793a))
* add helper for events without cancellation, use ([d0d642c](https://github.com/ssube/textual-engine/commit/d0d642cc11ee902e41149c61b74af652f38aa802))
* add service manager for batch stop ([422cc1c](https://github.com/ssube/textual-engine/commit/422cc1c45b4f7dc640fa0a80f39797dc9e812c04))
* combine entity slots and verbs into scripts, invoke verbs through script svc, split up scripts ([12dd40c](https://github.com/ssube/textual-engine/commit/12dd40c6d68b813822feea3755400c09ac7525a7))
* put loader on event bus ([#85](https://github.com/ssube/textual-engine/issues/85)), update main to fire events, add create world meta-command ([#70](https://github.com/ssube/textual-engine/issues/70)) ([81c9821](https://github.com/ssube/textual-engine/commit/81c9821b675cb7aa25f43954de8b0e1f961b0e62))
* queue commands in state for next step (fixes [#91](https://github.com/ssube/textual-engine/issues/91)), inform actor services of their actor(s), consolidate behavior actors (fixes [#88](https://github.com/ssube/textual-engine/issues/88)) ([a759b6e](https://github.com/ssube/textual-engine/commit/a759b6e2955966a91182a39ee28dee13403734e1))
* support custom verbs (fixes [#78](https://github.com/ssube/textual-engine/issues/78)), show actor verbs in help ([c7bfa2d](https://github.com/ssube/textual-engine/commit/c7bfa2da9c23c7097dd5d9edb06e5eac67e2da46))


### Bug Fixes

* trigger first render after input args ([76912bf](https://github.com/ssube/textual-engine/commit/76912bf8fe4f560f2cd85faf2fd529275e75f47b))
* **actor:** localize help and game over text, improve error handling ([2d4edef](https://github.com/ssube/textual-engine/commit/2d4edefe28bb4ee7e91fc424e3981064bf02f892))
* **build:** make it possible to switch layout for debug graph ([a973526](https://github.com/ssube/textual-engine/commit/a97352646162486f1942fc11e7851646510903b6))
* **build:** update esbuild exclude patterns ([d9cb18e](https://github.com/ssube/textual-engine/commit/d9cb18eb8c3c529ad1f990fe893e627b39dcc7cd))
* **command:** fix scrolling for debug meta-command ([080a2f2](https://github.com/ssube/textual-engine/commit/080a2f29bb34bc95f6934351c165bba109cec9fa))
* **data:** increase damage for bat teeth ([d21098d](https://github.com/ssube/textual-engine/commit/d21098d2f61e9af3a2148f0348bf8a943ebb6817))
* **data:** register common verbs for existing actors ([48e8fab](https://github.com/ssube/textual-engine/commit/48e8fab535fa271207df97cbb559b6825dcfc1e0))
* **data:** restore english text for debug graph ([a8cde9a](https://github.com/ssube/textual-engine/commit/a8cde9a32cca4bf157720d2a3cf650a361c502a3))
* **data:** show inventory item ID when looking ([940a920](https://github.com/ssube/textual-engine/commit/940a92059efb29b0ce4b62bc01351d589c73cea0))
* **data:** translate unknown verbs in error message ([04c29bf](https://github.com/ssube/textual-engine/commit/04c29bf2831754322f3de6ce5129433e7dc7c29b))
* **docs:** add animated snippet to readme ([6448df6](https://github.com/ssube/textual-engine/commit/6448df61210cf2ace9331ee8bc6e23c56ba99a6f))
* **docs:** add examples of template primitives ([#98](https://github.com/ssube/textual-engine/issues/98)) ([b51a285](https://github.com/ssube/textual-engine/commit/b51a2857f55979bbf3be65aeedad18d37807072a))
* **docs:** add table of service eventing, coupling ([ee7db0b](https://github.com/ssube/textual-engine/commit/ee7db0b902b40dbfe6b16641692d01a6ccadaf93))
* **docs:** describe common verbs in getting started ([13de49d](https://github.com/ssube/textual-engine/commit/13de49d13c115465ff2359822c502112d05fa941))
* **docs:** explain how to play ([715fc3b](https://github.com/ssube/textual-engine/commit/715fc3b72f6fa452627182d7533482f5f6d7ad12))
* **docs:** move custom verbs from planned to done ([e9c8dc1](https://github.com/ssube/textual-engine/commit/e9c8dc11e468992a5087022d9f1b6f740ecab2c0))
* **docs:** put services in their own doc ([0bd1411](https://github.com/ssube/textual-engine/commit/0bd14117682666dbc0a572caf23a312620e76f13))
* **module:** make parser and tokenizer singletons in core module ([f607a1e](https://github.com/ssube/textual-engine/commit/f607a1e3e7d809c59a5d4f557dca6282a560a880))
* **render:** auto-focus Ink input, use typed config for render ([01574de](https://github.com/ssube/textual-engine/commit/01574de1127f4a78adac8d4c98648ed68474bed3))
* **state:** type step event ([153c3d9](https://github.com/ssube/textual-engine/commit/153c3d9a2faa1f9dc89ff436af172123e21932a9))
* type actor and render output, eliminate redundant single-element arrays ([f5c019c](https://github.com/ssube/textual-engine/commit/f5c019c5ec6b2566a73cae61ac962b7ec832365d))
* **docs:** show major event flows ([02fdf35](https://github.com/ssube/textual-engine/commit/02fdf35fb7d83cbb6c0b5902fda6d4ebdc45464b))
* **docs:** update arch with new services, world templates with format changes ([#98](https://github.com/ssube/textual-engine/issues/98)) ([8a413a7](https://github.com/ssube/textual-engine/commit/8a413a7d4e588fb5129e82380c944cd2a3bf3dba))
* **render:** do not submit empty lines ([8ca6d01](https://github.com/ssube/textual-engine/commit/8ca6d011a8fc54efaf80ff4890a9119d20a5ae59))
* **script:** remove test broadcast script ([fa34063](https://github.com/ssube/textual-engine/commit/fa34063775b3c6aabbfd42b5444468cc79e442f7))
* **script:** split up verb scripts ([cc90062](https://github.com/ssube/textual-engine/commit/cc90062f584426b766284b2a37c921bc01d9a73d))
* **state:** add error messages for pre-state verbs (fixes [#99](https://github.com/ssube/textual-engine/issues/99)) ([0f703c6](https://github.com/ssube/textual-engine/commit/0f703c65f10472c8bed0ef009b5e97cc5c1035ec))
* **state:** clean up search params, remove leftover matcher params ([9e797a7](https://github.com/ssube/textual-engine/commit/9e797a7d9b8015b700a98e4eec40b69cb3782642))
* **state:** combine redundant searches for actor-room transfer, fix room expansion ([0ad9c17](https://github.com/ssube/textual-engine/commit/0ad9c1797db1ec7029a171a6c15301cc4a93048d))
* **state:** emit load event when world loads, not just after creation ([5191466](https://github.com/ssube/textual-engine/commit/5191466dfefa5d8ffc5aeef2294b3f3084e6f297))
* **state:** fire join event before adding new actor to room ([97bfb3e](https://github.com/ssube/textual-engine/commit/97bfb3e2ce11786fa8a98757f62bdd0140a31ff5))
* **state:** handle not-yet-valid verbs better ([#99](https://github.com/ssube/textual-engine/issues/99)), invoke room verbs correctly, do not overwrite signal scripts ([ab595f3](https://github.com/ssube/textual-engine/commit/ab595f3afc151eb7ff76913f8d9a28583e12ecfe))
* **state:** make transfer helper entity type checks more strict, test ([0241bad](https://github.com/ssube/textual-engine/commit/0241bad25f7b6530365438e41dd3f63c63d632f3))
* **state:** run initial room population before load event ([b32b3d1](https://github.com/ssube/textual-engine/commit/b32b3d13fa087c2d328bbf1bdc3bb58602a26d00))
* **state:** use existing player actor when loading (fixes [#100](https://github.com/ssube/textual-engine/issues/100)), keep player actor name and set id to pid ([844663d](https://github.com/ssube/textual-engine/commit/844663d0ab6bed1fb13b6e2917fdb5a7d55068d1))
* **state:** wait until loader indicates done before showing save message, check load event for state property rather than path, test ([edfac98](https://github.com/ssube/textual-engine/commit/edfac984e4516e886bfeff69d66b9a0501f5c18b))
* **test:** cover behavior actor eventing, node fetch loader, stub others ([1a3692b](https://github.com/ssube/textual-engine/commit/1a3692b289fe79d1ebe9a8141970f10a7c000136))
* **test:** cover more meta commands ([54d67bc](https://github.com/ssube/textual-engine/commit/54d67bc66027a436d1746956e4da0e1c74fdb891))
* **test:** cover player join, uninitialized state step ([bba0901](https://github.com/ssube/textual-engine/commit/bba09010559dfd30e4dc29b1424e3ecaf200d7a8))
* **test:** cover volume filter, stack map, state generator modifiers ([700c147](https://github.com/ssube/textual-engine/commit/700c147624d29b87bf53e8b2c6376a11ad64037a))
* **util:** split up state and script utils ([0cf60a6](https://github.com/ssube/textual-engine/commit/0cf60a6662e9946d8f3564118867bc504479f325))
* automatically create world when browser bundle starts ([29abd47](https://github.com/ssube/textual-engine/commit/29abd47edf3ea861d52793b400157351072b641a))
* copy full context when calling transfer scripts, test stack map more ([d0bbeab](https://github.com/ssube/textual-engine/commit/d0bbeaba9a212c90ba4cbcb3887f71ae14c33ab6))
* release services, listeners on quit, add event constants ([3832dfc](https://github.com/ssube/textual-engine/commit/3832dfc1128abee8a7529379c6ec27de2d8df284))
* update embedded config in index ([f19aa7d](https://github.com/ssube/textual-engine/commit/f19aa7ded890f423862a9b3a8d54eef826a56733))

## [1.3.0](https://github.com/ssube/textual-engine/compare/v1.2.0...v1.3.0) (2021-05-29)


### Features

* **actor:** make non-player actors move between rooms and attack players (fixes [#49](https://github.com/ssube/textual-engine/issues/49)) ([e503f38](https://github.com/ssube/textual-engine/commit/e503f380a58209dd634956f9fce7a68ad4d32d1a))
* **actor:** notify behavior actors of state changes ([b5a60a2](https://github.com/ssube/textual-engine/commit/b5a60a2f73d88ad09ac102c287b97041fac153dd))
* **build:** add esbuild bundle and browser entrypoint ([#7](https://github.com/ssube/textual-engine/issues/7)) ([0626e63](https://github.com/ssube/textual-engine/commit/0626e63f8689765fe0654ee238bbb5ff2ce7344b))
* **command:** move command uses index, target portals by group and/or name (fixes [#66](https://github.com/ssube/textual-engine/issues/66)) ([a311955](https://github.com/ssube/textual-engine/commit/a3119557701e49494dd3485898c2617455a23c18))
* **command:** roll random damage on hit (fixes [#65](https://github.com/ssube/textual-engine/issues/65)) ([4a9bce9](https://github.com/ssube/textual-engine/commit/4a9bce998cf9db848faf7eaa96fb6d5badc7e1be))
* **event:** consolidate events through a bus ([9f9e6b8](https://github.com/ssube/textual-engine/commit/9f9e6b8d95d79614fd5ebb513e0254360ac8411c))
* **loader:** add browser fetch loader (fixes [#77](https://github.com/ssube/textual-engine/issues/77)), split up node and browser loaders, load demo world from github ([7e51863](https://github.com/ssube/textual-engine/commit/7e518633a0e4a32469eee9b80cc50348d68ff5a9))
* **loader:** add node-fetch loader for http/s worlds ([#77](https://github.com/ssube/textual-engine/issues/77)) ([89470f7](https://github.com/ssube/textual-engine/commit/89470f78de829857520d724be42990532455d70c))
* **locale:** get current language from config (fixes [#84](https://github.com/ssube/textual-engine/issues/84)) ([d8e18ef](https://github.com/ssube/textual-engine/commit/d8e18ef1c3bc82bb078cf4bd8824633b99f7b576))
* **state:** filter output by source entity, room, and volume (fixes [#67](https://github.com/ssube/textual-engine/issues/67)) ([3b1637f](https://github.com/ssube/textual-engine/commit/3b1637f395c5ac1147b1bd9bb3dcb864c127c4e6))
* **state:** fully implement template modifiers (fixes [#6](https://github.com/ssube/textual-engine/issues/6)) ([836f28f](https://github.com/ssube/textual-engine/commit/836f28f3b4cb4e4f7c581eb615da4d499456935e))
* **state:** show help when game loop starts ([c46fa21](https://github.com/ssube/textual-engine/commit/c46fa21dfd7794286e954eacda92476175a26aa3))
* **state:** start applying template modifiers ([#6](https://github.com/ssube/textual-engine/issues/6)) ([d999962](https://github.com/ssube/textual-engine/commit/d9999623d2843b0ff8e37ca8e8113fdbb3a1cb56))
* **template:** use template primitives in modifiers, basic replacement string (fixes [#90](https://github.com/ssube/textual-engine/issues/90)) ([6a8c71d](https://github.com/ssube/textual-engine/commit/6a8c71da3cd1f01b39de1bdf89db4bae833bdab9))
* add base types for template modifiers ([#6](https://github.com/ssube/textual-engine/issues/6)) ([0b9c2e9](https://github.com/ssube/textual-engine/commit/0b9c2e95510bcd3bab8b0667e86430a9ac796f49))
* add React render, page loader, basic web UI ([#7](https://github.com/ssube/textual-engine/issues/7)) ([a3226ac](https://github.com/ssube/textual-engine/commit/a3226acb37bef9776caf5fa3c4c138a41fd7ed7d))
* generate unidirectional portals (fixes [#59](https://github.com/ssube/textual-engine/issues/59)) ([b96a040](https://github.com/ssube/textual-engine/commit/b96a040e65128affdb1c5313ec46790fb4fee493))
* parse real CLI arguments to main (fixes [#69](https://github.com/ssube/textual-engine/issues/69)) ([b359902](https://github.com/ssube/textual-engine/commit/b359902d8c4a1f9687bcc10d8e85f4f43be35e27))
* split actor service and tokenizer, type actor/render/state events ([dc7d635](https://github.com/ssube/textual-engine/commit/dc7d635e9bc90d048dc5bd3bba89d468c12da888))
* unify browser/node entrypoints, enable DI modules through main args ([ad12a7f](https://github.com/ssube/textual-engine/commit/ad12a7f4e5578a551c4d44f7112ec17ec18c9386))
* use event bus throughout, strip whitespace from command parts, move common verbs to config, make portal depth an argument ([320e5f7](https://github.com/ssube/textual-engine/commit/320e5f7f1b4c1725ede22776829591009ce242a1))
* **template:** add step to template number (fixes [#58](https://github.com/ssube/textual-engine/issues/58)) ([5c036b0](https://github.com/ssube/textual-engine/commit/5c036b0f4e41e15c7445e1d7d3b73fcfe87f8b72))
* **template:** render verb and mixed-primitive maps ([685dfe7](https://github.com/ssube/textual-engine/commit/685dfe7edfa849bba49af056a5e0393952820b42))
* **util:** add and test entity containment helpers (fixes [#53](https://github.com/ssube/textual-engine/issues/53)) ([7932e27](https://github.com/ssube/textual-engine/commit/7932e27dd04e5de1eb66dd88ba8a83b9333cda09))
* **world:** record starting actor and room in saved state (fixes [#68](https://github.com/ssube/textual-engine/issues/68)) ([e64e561](https://github.com/ssube/textual-engine/commit/e64e56114385cf16b5680a60071d4644cfaa7ed3))


### Bug Fixes

* **build:** copy entry HTML to output ([06e4c8d](https://github.com/ssube/textual-engine/commit/06e4c8d2a52e7e0f4c5304dda28297825e054605))
* **build:** exclude docs, bundles from coverage ([2daee6d](https://github.com/ssube/textual-engine/commit/2daee6d28ca28fa0e4155d4effd438ccc28c1714))
* **build:** process coverage correctly for repeat bundle builds ([50842fa](https://github.com/ssube/textual-engine/commit/50842fa6df9b9342ee87e341daa89661c828f75e))
* **build:** rename push branch var to fix CC report branch ([03e9541](https://github.com/ssube/textual-engine/commit/03e954169cd4952f6e14591f7df21a4e9984f076))
* **command:** add localized error when portal is missing, describe room on entry ([8a4e63d](https://github.com/ssube/textual-engine/commit/8a4e63df204f2f71c54d4ce43f7f64a888d92296))
* **command:** filter hit messages (fixes [#82](https://github.com/ssube/textual-engine/issues/82)) ([28c239b](https://github.com/ssube/textual-engine/commit/28c239bf1f14098d87e179f8eb547e2047d1b1af))
* **command:** only allow actors to drop items from their own inventory ([#64](https://github.com/ssube/textual-engine/issues/64)) ([e46165e](https://github.com/ssube/textual-engine/commit/e46165e406d490acdd40a2c8e4c40adaaecb1fdc))
* **command:** only take items in the current room, prevent accidental pickpocketing (fixes [#64](https://github.com/ssube/textual-engine/issues/64)) ([dbb6634](https://github.com/ssube/textual-engine/commit/dbb6634bdfeeb0537aa9d988af74762bc83399a2))
* **command:** print help verbs as lines to fix translation ([9b455f0](https://github.com/ssube/textual-engine/commit/9b455f04f591da49ca9a3ce60a25fabdaa7bac83))
* **component:** monospace React output ([3d18347](https://github.com/ssube/textual-engine/commit/3d1834783f81865110be57fde9ab640212bff0ca))
* **data:** add marsh room ([fd3e64a](https://github.com/ssube/textual-engine/commit/fd3e64a02f2e8968d3d3f45476d162464c4467f9))
* **data:** correct damage modifier for shiny swords ([0ad032d](https://github.com/ssube/textual-engine/commit/0ad032d5dd8aa0bea8c0783c6f0760f63f312d48))
* **data:** give multiple possible destinations to more portals ([1be1635](https://github.com/ssube/textual-engine/commit/1be16359cefd2e4c91f5f3ea1c8257c0c3fce41b))
* **docs:** add snippet image to reamde ([42a1c95](https://github.com/ssube/textual-engine/commit/42a1c95643831ccbf9ef6a52309ee9ef09bbc0fc))
* **docs:** link dev, worlds from getting started ([ecb0d7e](https://github.com/ssube/textual-engine/commit/ecb0d7e297a7bf97276f49b4e51ed578b2cc60a9))
* **docs:** link readme image to GH pages ([728b5f4](https://github.com/ssube/textual-engine/commit/728b5f4ce5d7a3d5e9896a9e8bcaca3552a55d4e))
* **docs:** mention GH pages in readme ([1ec1326](https://github.com/ssube/textual-engine/commit/1ec13262ce5f82eaa993e23cff0ca915e0264fc6))
* **locale:** log when adding locale bundles ([2de2471](https://github.com/ssube/textual-engine/commit/2de2471e24a642d94c7914bb9b1d054421b16b55))
* **module:** export actor locator rather than calling DI container during state steps ([3c1903d](https://github.com/ssube/textual-engine/commit/3c1903d5c3ce00f540c61295257c493378bab74b))
* **module:** remove player-actor injection symbol, ensure actor service only starts once ([8469297](https://github.com/ssube/textual-engine/commit/8469297526a94163dbb3d0b248a16c6f431df3cf))
* **random:** generate integers correctly when min equals max ([bcc6f33](https://github.com/ssube/textual-engine/commit/bcc6f33bbf329c5525c413338c44feab2b1c201e))
* **random:** remove unused ID method, cover the rest with tests ([df2d5d6](https://github.com/ssube/textual-engine/commit/df2d5d6776b59267072f3b8ade96a00f8c7a51f2))
* **render:** add debounce helper for React output, unused ([b7a57d9](https://github.com/ssube/textual-engine/commit/b7a57d9b0bfd25a42444cb82e69a92086659096d))
* **render:** add kind field to ink render logs ([b17fc26](https://github.com/ssube/textual-engine/commit/b17fc26a212b96e9b6c7c07fb95ad50c820968c8))
* **render:** unify React-based render frontends ([ee497c5](https://github.com/ssube/textual-engine/commit/ee497c5c02da98304e6fbe44b6d36acfd1c7503d))
* **render:** update React turn indicator ([dea790e](https://github.com/ssube/textual-engine/commit/dea790e6b2ee25ae18bc37fa293da36a9648cb6f))
* **script:** flatten actor step logic, cover with tests ([5e71721](https://github.com/ssube/textual-engine/commit/5e7172114524902626f5f9d3948f83e25e0534a7))
* **script:** prevent actors from hitting themselves ([#64](https://github.com/ssube/textual-engine/issues/64)) ([c2e59fb](https://github.com/ssube/textual-engine/commit/c2e59fbb03987d03fab1e4b3391c1fbc5508ed66))
* **state:** DRY up generator logic, add template ref list methods ([8d9294f](https://github.com/ssube/textual-engine/commit/8d9294f09552e441f6d3403f453a12d09587d889))
* **state:** print help on a single line again, but translated ([2877e01](https://github.com/ssube/textual-engine/commit/2877e01480bc764d834615af6d325129391163af))
* **test:** begin testing input services, fix errors ([db0e356](https://github.com/ssube/textual-engine/commit/db0e3569016cdbcd1f00e8bb39f6f6746ae914cc))
* **test:** cover collection rendering in chain template ([9def185](https://github.com/ssube/textual-engine/commit/9def1856bce5b51f7e82c8a24b196d617e05bde3))
* **test:** cover i18next locale, local script services ([25a2e7a](https://github.com/ssube/textual-engine/commit/25a2e7a8518b8e3e7126277025ae11881a2f6c43))
* **test:** cover local ID counter, chain template engine ([4e1c7a9](https://github.com/ssube/textual-engine/commit/4e1c7a9034ea75f29e6514e95de71cfa13bbda84))
* **test:** cover page loader ([931158d](https://github.com/ssube/textual-engine/commit/931158dc1b800bf034b9b6a385fe5e746d129c0d))
* **test:** cover state focus helper ([c9273c9](https://github.com/ssube/textual-engine/commit/c9273c93aa1c1eacbbc8ba81cb861bbca7a135ab))
* **test:** cover YAML parser ([ecbc828](https://github.com/ssube/textual-engine/commit/ecbc828b2f506c812ec3d072b02948a8fbe348dd))
* **util:** clean up debug graph portal labels ([c6a4b29](https://github.com/ssube/textual-engine/commit/c6a4b2915d5079fb673a3ab16e81d7e16ebbb515))
* **util:** correct ID prefix matching, test that and tranfer helper ([7174c30](https://github.com/ssube/textual-engine/commit/7174c309483eaf7fafafc37a764e0e2a3828af1f))
* **world:** reduce the chances of normal goblins having swords ([95679c4](https://github.com/ssube/textual-engine/commit/95679c4c68ab9e2fcf1f26987017a576dbad3b98))
* replace incorrectly-used invalid target errors ([adc429c](https://github.com/ssube/textual-engine/commit/adc429c40a43cb3f1022a68a9f6a42a0d41a5017))
* use typed errors ([0784fcd](https://github.com/ssube/textual-engine/commit/0784fcd8e9bf59b1fa9f12864e270d46f17404c2))

## [1.2.0](https://github.com/ssube/textual-engine/compare/v1.1.0...v1.2.0) (2021-05-23)


### Features

* **input:** translate verbs before sending commands ([e03f0f5](https://github.com/ssube/textual-engine/commit/e03f0f5cfb12fac16c1988af58f9b56c07d232da))
* **state:** localize output while streaming ([#60](https://github.com/ssube/textual-engine/issues/60)), select random dest portal from options ([5ed643c](https://github.com/ssube/textual-engine/commit/5ed643caeb6338af485d96daa9031625254ce620))
* begin loading and using locale from config ([0645a3e](https://github.com/ssube/textual-engine/commit/0645a3eb0d06d845d068bcac0ad98577e9c29957))
* make state event emitter, consume events from render ([#63](https://github.com/ssube/textual-engine/issues/63)) ([3722671](https://github.com/ssube/textual-engine/commit/37226710b3797216f76286e5949ae5ad757cedda))
* **build:** add docker image, split up dev and prod deps ([a9d4cbe](https://github.com/ssube/textual-engine/commit/a9d4cbea71ee8dd68d8f9b1c6150a43b32d9f61a))
* **build:** add eslint target ([90186a0](https://github.com/ssube/textual-engine/commit/90186a0fa2d74d005039bf187137b2c5f5e0b06b))
* **build:** add gitlab CI pipeline ([11e99f4](https://github.com/ssube/textual-engine/commit/11e99f43dc512e448ac7008b506b7c55a46f4123))
* **command:** add item get slot to actors and show item info (fixes [#45](https://github.com/ssube/textual-engine/issues/45)) ([dd03793](https://github.com/ssube/textual-engine/commit/dd03793fd947b49eafef300984f0601060045f3c))
* **command:** honor target for look command (fixes [#5](https://github.com/ssube/textual-engine/issues/5)) ([31b6d0f](https://github.com/ssube/textual-engine/commit/31b6d0fd6674e4237dc2b941fcd200deab879841))
* **command:** look up local target for use command (fixes [#28](https://github.com/ssube/textual-engine/issues/28)) ([3c96730](https://github.com/ssube/textual-engine/commit/3c96730c84f9c8319b0e0c624bd437c17ea67315))
* **command:** use command target for actor step target searches, disable actor step after death ([69cb0e8](https://github.com/ssube/textual-engine/commit/69cb0e852d1bf1ca8fcef4eeccc4be55245bd9b1))
* **input:** move actor/input mapping into DI module ([f2c3c7f](https://github.com/ssube/textual-engine/commit/f2c3c7f22e0f45e04b33687600750b4562bf7530))
* **input:** parse target index from commands ([4de58c7](https://github.com/ssube/textual-engine/commit/4de58c79bc8705ca40d14cf31a0d2e865efc8333))
* **module:** split input services into their own module ([2741b22](https://github.com/ssube/textual-engine/commit/2741b2278e944f8fcef167c839151673e1a1ff21))
* **render:** add marker in between turns (fixes [#48](https://github.com/ssube/textual-engine/issues/48)) ([87207ec](https://github.com/ssube/textual-engine/commit/87207ec0ca00353d1275065ef7f8f11364f298d8))
* **template:** reverse join chain operator order, AND first ([d72d955](https://github.com/ssube/textual-engine/commit/d72d955d06388bd9ed7c8d6d758b0eab53c02525))
* **util:** provide singleton factory in constructor ([79164b5](https://github.com/ssube/textual-engine/commit/79164b5c1a52e775c24e7f373007d5a6b9a64a02))
* **world:** add chance to template refs (fixes [#55](https://github.com/ssube/textual-engine/issues/55)) ([aed8219](https://github.com/ssube/textual-engine/commit/aed8219f6e0ebae630e847aeb226b1423067f1b7))
* **world:** extract focus and transfer helpers from state svc ([#50](https://github.com/ssube/textual-engine/issues/50)) ([4c97f1b](https://github.com/ssube/textual-engine/commit/4c97f1b2caa891449d5c39ac3c2be217d60a3775))
* **world:** implement save/load for local state ([c866e64](https://github.com/ssube/textual-engine/commit/c866e64ebd701cea74319463ddd296327f474cff))
* **world:** turn name/desc into template strings and start actor/room into template refs ([c1fca0c](https://github.com/ssube/textual-engine/commit/c1fca0c7972872daa3a7728cf04a02c7db8eba5e))
* move meta command handling to state service ([d4a9b14](https://github.com/ssube/textual-engine/commit/d4a9b148f7c91d2182e42677af2068b9296d2790))


### Bug Fixes

* **build:** add codeclimate and npm configs ([1243a99](https://github.com/ssube/textual-engine/commit/1243a9987ed2d954d6dfa8cb1154c88eb26fe5ac))
* **build:** add coverage and help targets, help for others ([8f3d94e](https://github.com/ssube/textual-engine/commit/8f3d94e083a20a4eacda01fdfff3925e53c6db29))
* **build:** lower coverage reqs to match current tests ([38a3283](https://github.com/ssube/textual-engine/commit/38a3283f58bc8e66aa63d0256a08bc6e93867b10))
* **build:** make docker image script fail if build or push does ([9c2f1eb](https://github.com/ssube/textual-engine/commit/9c2f1eb57ae7dc95533a9518da12cdf72ce0b8cd))
* **build:** make docker image variable, DRY up run targets ([353938e](https://github.com/ssube/textual-engine/commit/353938ed1a3dbf0eec18e3b784c4d3f7c9b5e5e8))
* **build:** remove noop CC prep job ([f0b3614](https://github.com/ssube/textual-engine/commit/f0b36149392ec9e341704f3e3a01d75b88e58157))
* **component:** remove output from Ink/React state ([d32dae5](https://github.com/ssube/textual-engine/commit/d32dae57e17adbd6be55ddd15734bd3483b08004))
* **docs:** cover build targets, debugging ([043522d](https://github.com/ssube/textual-engine/commit/043522d53ad40bccd3e27bea6b9eeee7d32690a8))
* **render:** remove extra newline, fix input height for ink render ([86434ad](https://github.com/ssube/textual-engine/commit/86434ad5c6b9d556e6e91a87195da8311c909162))
* **render:** use text box component in ink render that supports scrolling ([c272d0b](https://github.com/ssube/textual-engine/commit/c272d0bdb0e9d85d360662eb3b5be24f5b23724b))
* translate verbs when world is created, remove min param from map increment helper, various lint fixes ([7657454](https://github.com/ssube/textual-engine/commit/76574549b2ee775a45e3be338a88d5cea283fd25))
* **build:** add CI target ([e58adea](https://github.com/ssube/textual-engine/commit/e58adea40c30258e3c9f9f60afe9ecf6624cef07))
* **build:** specify paths for CC upload ([56ea58c](https://github.com/ssube/textual-engine/commit/56ea58c37fc9d96b4ea9453a74f6453f837a3e71))
* **docs:** describe most world template fields ([9a6f389](https://github.com/ssube/textual-engine/commit/9a6f389376d7c7ad46ce422f7ddf090f4cd3d7f7))
* **docs:** start describing world format, authoring ([42e25b2](https://github.com/ssube/textual-engine/commit/42e25b2763875d01df7b0e61310b4541eee3133a))
* **lint:** give single-letter generic params better names ([1b240fe](https://github.com/ssube/textual-engine/commit/1b240fe8962f2da35117f02342366c0bc9c95ccf))
* **lint:** initial cleanup ([77f7e97](https://github.com/ssube/textual-engine/commit/77f7e9703bdef8b6a622323af013d90787a79477))
* **lint:** move components out of render tree ([8a7a707](https://github.com/ssube/textual-engine/commit/8a7a707b6abfee78146e553454a9ed4be374c9cb))
* **lint:** remove unnecessary cast, some obsolete todos ([e141fd7](https://github.com/ssube/textual-engine/commit/e141fd7923adcff85e8915d5c793161c65c7250a))
* **lint:** rename script scope to context, which it is ([5bdf6da](https://github.com/ssube/textual-engine/commit/5bdf6dab8b416b8266cb3488de2d599227002170))
* **lint:** round 2 ([3d87338](https://github.com/ssube/textual-engine/commit/3d87338c65c29fdf64514384c42b748ed28f5306))
* **locale:** localize existing strings, improve some logs ([fd4d769](https://github.com/ssube/textual-engine/commit/fd4d7694d52a822d53a8f259ff04e25603a9f6ce))
* **module:** use singleton helper in DI modules ([3ce8e44](https://github.com/ssube/textual-engine/commit/3ce8e44f897956181260fe5ea2fcec006601d1d4))
* **render:** consolidate line render prompts, limit ink render history size ([a5c415a](https://github.com/ssube/textual-engine/commit/a5c415a8f51bf4b67b0b006ca6d42ce098ef5297))
* **render:** ensure line render writes output before next prompt ([26b26e6](https://github.com/ssube/textual-engine/commit/26b26e63a35d421d4f958caa5b5fc99920bb944b))
* **render:** handle errors within effects when event listeners are released early ([9003a5d](https://github.com/ssube/textual-engine/commit/9003a5d7b0807f00c6e0064d8c901ed0429c9512))
* **render:** move step output display to render hook ([25f0d3b](https://github.com/ssube/textual-engine/commit/25f0d3b0d7b572978fc7ea701a7ea2095573a668))
* **render:** put newline between turn prompt and output on line render ([d5ad920](https://github.com/ssube/textual-engine/commit/d5ad9204e09a537900d0bc3bfdb23437343ddadf))
* **render:** remove event listeners during component cleanup ([a95934f](https://github.com/ssube/textual-engine/commit/a95934fd10154beb84156c07240f55b8b1bda89c))
* **render:** remove logger-render adapter, do not write world state to logs on exit ([306a791](https://github.com/ssube/textual-engine/commit/306a79145f82503b97833b9f06f535c3999a8e71))
* **render:** show turn prompt, split input into its own module ([b3713eb](https://github.com/ssube/textual-engine/commit/b3713eb61da6ddf0ec95b8998196910012b14e6b))
* **state:** extract world generator helper from state service ([19d3b6b](https://github.com/ssube/textual-engine/commit/19d3b6bb739bc281803e4fc47d792dd6f02e42ae))
* **state:** refresh focus and transfer helpers on state load ([0e77722](https://github.com/ssube/textual-engine/commit/0e777226e487afb6ff3716649b5ab8a8ad2160fc))
* update line render to work with new events, clean up meta commands ([c72fc5d](https://github.com/ssube/textual-engine/commit/c72fc5ddede579f5eeaaf317658e895bde89f476))
* **render:** pass step result directly to ink state, split step and line state ([531a3eb](https://github.com/ssube/textual-engine/commit/531a3ebecb7538cdaa760c99d0656be923fd4a28))
* **script:** only describe current room if no target is passed to look ([b27c15e](https://github.com/ssube/textual-engine/commit/b27c15eb7fa6cf7afc91f81b0e0bd4fb63da1d50))
* **script:** only print command info for player ([af3efe6](https://github.com/ssube/textual-engine/commit/af3efe61e92f39066f16752d819c864db8fe3b8c))
* **script:** send command feedback to render output ([8619bf1](https://github.com/ssube/textual-engine/commit/8619bf187b568b109f81d18e85436d21b0762f66))
* **template:** join templates with spaces now that IDs are not templates (fixes [#52](https://github.com/ssube/textual-engine/issues/52)) ([f2acbb0](https://github.com/ssube/textual-engine/commit/f2acbb0387337028d39c4e2d2b41862c903cd2a6))
* **test:** cover map and state debug helpers ([283c8ba](https://github.com/ssube/textual-engine/commit/283c8ba830c95329dc03bd97376b4934154de5b5))
* **test:** cover models, register chai-as-promised ([ba6cc55](https://github.com/ssube/textual-engine/commit/ba6cc5598e3b3ba2920eb81c8a9195f97dc3193b))
* **test:** join chain tests for AND/OR flip ([9311363](https://github.com/ssube/textual-engine/commit/9311363e7b6adbeae60125e352e883354ffe8ca0))
* **util:** make state debug utils return output as strings rather than rendering ([fa9a26f](https://github.com/ssube/textual-engine/commit/fa9a26f6293284c7ee469c2748078fc83092f0ba))
* **util:** reduce looping when searching state, support custom matchers (fixes [#44](https://github.com/ssube/textual-engine/issues/44)) ([a305361](https://github.com/ssube/textual-engine/commit/a305361281bcc7bf8ef1d4e55e2f29ee0d815595))
* **world:** do not template entity IDs (fixes [#54](https://github.com/ssube/textual-engine/issues/54)) ([c51434d](https://github.com/ssube/textual-engine/commit/c51434d5c6b6ff1c211d3dcad1660a95dae8f386))
* **world:** match entities by ID segment when searching state (fixes [#57](https://github.com/ssube/textual-engine/issues/57)) ([50708bc](https://github.com/ssube/textual-engine/commit/50708bc5cc2fd02805928e7df19e0786f3cb8c7f))
* **world:** remove redundant lookup from transfer helpers, since clients already have target info ([518d94c](https://github.com/ssube/textual-engine/commit/518d94c517c68deedc7fd3837e6b65b08d470333))
* make sure service loggers create a child with their constructor name ([4c106f6](https://github.com/ssube/textual-engine/commit/4c106f6e02905ab3577f0bc0182ecea1616af36f))
* remove controller nomenclature ([7ae4fe8](https://github.com/ssube/textual-engine/commit/7ae4fe85039db2e358574404b98eb4c8bb662e96))

## [1.1.0](https://github.com/ssube/textual-engine/compare/v1.0.0...v1.1.0) (2021-05-16)


### Features

* **command:** implement actor hit command ([e25be91](https://github.com/ssube/textual-engine/commit/e25be91ea95646eeccea8f85d3e917936f2689fb))
* **config:** load logger options from config ([1e38a04](https://github.com/ssube/textual-engine/commit/1e38a041b11cd315d5ead2f97cdd28096a265f0f))
* **config:** validate config data before use ([d49d597](https://github.com/ssube/textual-engine/commit/d49d5975442f1a5e9601a8dfd55e56ded6c8af5c))
* **loader:** validate most data file fields ([071e543](https://github.com/ssube/textual-engine/commit/071e543c38fc93d587c5c3b7064a9de36c2d49f5))
* **render:** add Ink renderer with history and input ([c2ffe69](https://github.com/ssube/textual-engine/commit/c2ffe69c8234b7e1fb41edcdac52a1403769a458))
* **render:** limit Ink render history length, exit cleanly ([40c3a44](https://github.com/ssube/textual-engine/commit/40c3a44fb82d45b455e17d79d39aa595e194621a))
* **render:** push main loop into render ([dd6a53d](https://github.com/ssube/textual-engine/commit/dd6a53dcc61a820648b0af7cdb55afe0f888e4a2))
* **script:** add room id to look output ([201e28e](https://github.com/ssube/textual-engine/commit/201e28e5fe46fa4919744dfd7d0509ccc3b382dc))
* **state:** implement item transfer, drop/take commands ([b823475](https://github.com/ssube/textual-engine/commit/b8234752ae64703f88316f72ce37955ab61731a4))
* **util:** add state search helper for name or id ([2266380](https://github.com/ssube/textual-engine/commit/2266380065067e193c6bacd2001fd6d01c753a1d))


### Bug Fixes

* **render:** remove handlers individually rather than by name ([2f8289e](https://github.com/ssube/textual-engine/commit/2f8289ede33a829ed1438b321994da745860bde8))
* **script:** use scope state for broadcast search ([7a1c5de](https://github.com/ssube/textual-engine/commit/7a1c5de0da7495d86d32b48526be4d4f4eae7597))
* **state:** prevent transfer when target item is not in the same room, or when source and dest are the same ([1a418a6](https://github.com/ssube/textual-engine/commit/1a418a6266f130d4eea8c8540c18429cd7b43a26))
* **template:** use group/item delimiters from options when splitting ([76b1fe6](https://github.com/ssube/textual-engine/commit/76b1fe66984756e9089a48e1a5697f7bc0ef0aee))
* **util:** move async tracker out of main ([30d6341](https://github.com/ssube/textual-engine/commit/30d6341f04561268dc4dbf0eb545c256084f77c8))

## 1.0.0 (2021-05-15)


### Features

* **build:** add release target ([3aa9356](https://github.com/ssube/textual-engine/commit/3aa9356eed00211cf479167466aca1465fe18b1b))
* **build:** add standard-version for changelog and tagging ([b9cbb4f](https://github.com/ssube/textual-engine/commit/b9cbb4f0368f296f58cf87481e345ffc8ccbecbc))
